class String
  def truncate! length, position = :middle
    case position
    when :middle
      replace ellipsize length
    end
  end

  def ellipsize length = 9
    return self if self.size <= length

    remainder = length - 3
    offset = remainder / 2
    (self[0, offset + (remainder.odd? ? 1 : 0)].to_s + '…' + self[-offset, offset].to_s)[0, length].to_s
  end unless defined? ellipsize
end
